
#Include Once "windows.bi"
#include once "win/richedit.bi"
#include once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "inc/md5.bi"
#Include Once "inc/http.bi"
#Include Once "inc/win_clipboard.bi"
#Include Once "inc/xml.bi"

#Include Once "fbedit/raedit.bi"
#Include Once "fbedit/addins.bi"

#Include Once "porticulaplugin.bi"


'#Include Once "debug.bi"



Declare Sub UpdateThread(param As Any Ptr)
Declare Sub UpdControls(ByVal hWin As HWND)



Sub AddToMenu(ByVal id As Integer, ByVal menu As UInteger, ByVal title As String)
	Dim mii As MENUITEMINFO
	mii.cbSize = SizeOf(MENUITEMINFO)
	mii.fMask = MIIM_SUBMENU
	GetMenuItemInfo(lpHANDLES->hmenu, menu, FALSE, @mii)
	AppendMenu(mii.hSubMenu, MF_STRING, id, StrPtr(title))
End Sub

Sub AddToAccelerator(ByVal fvirt As Integer, ByVal akey As Integer, ByVal id As Integer)
	Dim nAccel As Integer
	Dim acl(500) As ACCEL

	nAccel = CopyAcceleratorTable(lpHandles->haccel, NULL, 0)
	CopyAcceleratorTable(lpHandles->haccel, @acl(0), nAccel)
	DestroyAcceleratorTable(lpHandles->haccel)
	acl(nAccel).fVirt = fvirt
	acl(nAccel).key = akey
	acl(nAccel).cmd = id
	nAccel = nAccel+1
	lpHandles->haccel = CreateAcceleratorTable(@acl(0), nAccel)
End Sub


Sub UpdateAccelerator(ByVal fvirt As Integer, ByVal akey As Integer, ByVal id As Integer)
	Dim nAccel As Integer
	Dim acl(500) As ACCEL
	Dim q As Integer
	Dim w As Integer = 0

	nAccel = CopyAcceleratorTable(lpHandles->haccel, NULL, 0)
	CopyAcceleratorTable(lpHandles->haccel, @acl(0), nAccel)
	For q = 0 To nAccel - 1
		If acl(q).cmd = id Then
			If akey = 0 Then
				nAccel -= 1
				For w = q To nAccel-1
					acl(q) = acl(q+1)
				Next
				w = 2
			Else
				acl(q).fVirt = fvirt
				acl(q).key = akey
				acl(q).cmd = id
				w = 1
			End If
		End If
	Next
	If w = 0 And akey <> 0 Then
		acl(nAccel).fVirt = fvirt
		acl(nAccel).key = akey
		acl(nAccel).cmd = id
		nAccel = nAccel+1
		w = 3
	End If
	If w <> 0 Then
		DestroyAcceleratorTable(lpHandles->haccel)
		lpHandles->haccel = CreateAcceleratorTable(@acl(0), nAccel)
	End If
End Sub

Function TranslateModifiers(ByVal modifiers As Integer) As Integer
	Dim q As Integer = 0
	If modifiers And HOTKEYF_ALT Then q = q Or FALT
	If modifiers And HOTKEYF_SHIFT Then q = q Or FSHIFT
	If modifiers And HOTKEYF_CONTROL Then q = q Or FCONTROL
	Return q
End Function


Function CheckHotkey(ByVal vkey As Integer, ByVal modifiers As Integer, ByVal id As Integer) As Integer
	Dim nAccel As Integer
	Dim acl(500) As ACCEL
	Dim tmpKey As Integer
	Dim mods As Integer = TranslateModifiers(modifiers)
	Dim key2 As integer
	Dim mods2 As Integer
	
	nAccel = CopyAcceleratorTable(lpHandles->haccel, NULL, 0)
	CopyAcceleratorTable(lpHandles->haccel, @acl(0), nAccel)
	For q As Integer = 0 To nAccel - 1
		If acl(q).fVirt And FVIRTKEY Then
			If acl(q).cmd = id Then Continue For
			If vkey <> acl(q).key Then Continue For
			If mods <> (acl(q).fVirt And (FALT Or FSHIFT Or FCONTROL)) Then Continue For
		Else
			tmpKey = VkKeyScan(acl(q).key)
			If LoByte(tmpKey) = -1 And HiByte(tmpKey) = -1 Then Continue For
			If LoByte(tmpKey) <> vkey Then Continue For
			mods2 = acl(q).fVirt And (FALT Or FSHIFT Or FCONTROL)
			If HiByte(tmpKey) And 1 Then mods2 = mods2 Or FSHIFT
			If HiByte(tmpKey) And 2 Then mods2 = mods2 Or FCONTROL
			If HiByte(tmpKey) And 4 Then mods2 = mods2 Or FALT
			If mods2 <> mods Then Continue For
		End If
		Return 1
		
		'If acl(q).fVirt And FVIRTKEY Then
		'	If acl(q).key <> vkey Then Continue For
		'	If IIf(acl(q).fVirt And FSHIFT, 1, 0) <> IIf(modifiers And HOTKEYF_SHIFT, 1, 0) Then Continue For
		'	If IIf(acl(q).fVirt And FCONTROL, 1, 0)  <> IIf(modifiers And HOTKEYF_CONTROL, 1, 0) Then Continue For
		'	If IIf(acl(q).fVirt And FALT, 1, 0) <> IIf(modifiers And HOTKEYF_ALT, 1, 0) Then Continue For
		'Else
		'	tmpKey = VkKeyScan(acl(q).key)
		'	If LoByte(tmpKey) = -1 And HiByte(tmpKey) = -1 Then Continue For
		'	If LoByte(tmpKey) <> vkey Then Continue For
		'	If (IIf(acl(q).fVirt And FSHIFT, 1, 0) Or IIf(HiByte(tmpKey) And 1, 1, 0)) <> IIf(modifiers And HOTKEYF_SHIFT, 1, 0) Then Continue For
		'	If (IIf(acl(q).fVirt And FCONTROL, 1, 0) Or IIf(HiByte(tmpKey) And 2, 1, 0)) <> IIf(modifiers And HOTKEYF_CONTROL, 1, 0) Then Continue For
		'	If (IIf(acl(q).fVirt And FALT, 1, 0) Or IIf(HiByte(tmpKey) And 4, 1, 0)) <> IIf(modifiers And HOTKEYF_ALT, 1, 0) Then Continue For
		'	Return q+1
		'End If
	Next
	Return 0
End Function


Function SettingsProc(ByVal hWin As HWND, ByVal uMsg As UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Dim q As Integer
	Dim tmpStr As String
	Dim dummyStr As String = String(7, 255)
	
	Select Case uMsg
		Case WM_INITDIALOG
			SendDlgItemMessage(hWin, IDC_PWD, WM_SETFONT, Cast(WPARAM, GetStockObject(DEFAULT_GUI_FONT)), TRUE)
			SetWindowText(GetDlgItem(hWin, IDC_USN), StrPtr(Username))
			If PassHash <> "" Then SetWindowText(GetDlgItem(hWin, IDC_PWD), StrPtr(dummyStr))
			CheckDlgButton(hWin, IDC_CHKUPDATES, IIf(Sett.updates <> 0, BST_CHECKED, BST_UNCHECKED))
			CheckDlgButton(hWin, IDC_CHKAUTOLOAD, IIf(Sett.autoload <> 0, BST_CHECKED, BST_UNCHECKED))
			SendDlgItemMessage(hWin, IDC_HOTKEY, HKM_SETRULES, HKCOMB_NONE Or HKCOMB_S, HOTKEYF_CONTROL)
			SendDlgItemMessage(hWin, IDC_HOTKEY, HKM_SETHOTKEY, Sett.hotkey, 0)
			
		Case WM_CLOSE
			EndDialog(hWin, 0)
			
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case IDC_CANCEL
					SendMessage(hWin, WM_CLOSE, 0, 0)
					
				Case IDC_OK
					Dim As String tmpUsn, tmpPwd
					Dim As Integer tmpHotkey
					q = GetWindowTextLength(GetDlgItem(hWin, IDC_USN))
					tmpUsn = String(q, 0)
					GetWindowText(GetDlgItem(hWin, IDC_USN), StrPtr(tmpUsn), q+1)
					q = GetWindowTextLength(GetDlgItem(hWin, IDC_PWD))
					tmpPwd = String(q, 0)
					GetWindowText(GetDlgItem(hWin, IDC_PWD), StrPtr(tmpPwd), q+1)
					If Trim(tmpUsn) = "" Then MessageBox(hWin, @"Bitte geben Sie einen Benutzernamen ein!", @"Fehler", MB_OK Or MB_ICONWARNING) : Exit Select
					If Trim(tmpPwd) = "" Then MessageBox(hWin, @"Bitte geben Sie Ihr Passwort ein!", @"Fehler", MB_OK Or MB_ICONWARNING) : Exit Select
					tmpHotkey = SendDlgItemMessage(hWin, IDC_HOTKEY, HKM_GETHOTKEY, 0, 0)
					If LoByte(tmpHotkey) <> 0 Then
						If CheckHotkey(LoByte(tmpHotkey), HiByte(tmpHotkey), IDM_PORTICULA) <> 0 Then
							MessageBox(hWin, @"Das ausgewhlte Tastaturkrzel wird bereits anderwrtig verwendet. Bitte whlen Sie eine andere Kombination!", @"Fehler", MB_OK Or MB_ICONWARNING)
							Exit Select
						End If
					End If
					If tmpPwd <> dummyStr Or tmpUsn <> Username Then
						If tmpPwd <> dummyStr Then tmpPwd = md5(tmpPwd) Else tmpPwd = PassHash
						fbpApiUrl.Query = "action=check&username=" + URLEncode(tmpUsn) + "&pwhash=" + URLEncode(tmpPwd)
						If getHTTP(fbpApiUrl, tmpStr) <> "" Then
							MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
							Exit Select
						End If
						If tmpStr <> "SUCCESS" Then
							If tmpStr = "BLOCKED" Then
								MessageBox(hWin, @("Ihr Zugang wurde nach einigen Fehlversuchen gesperrt." & CRLF & "Warten Sie einige Minuten und versuchen Sie es anschlieend erneut!"), @"Fehler", MB_OK Or MB_ICONERROR)
							Else
								MessageBox(hWin, @("Benutzername oder Kennwort sind ungltig." & CRLF & "Bitte geben Sie eine gltige Kombination ein!"), @"Fehler", MB_OK Or MB_ICONERROR)
							End If
							Exit Select
						End If
						Username = tmpUsn
						PassHash = tmpPwd
					End If
					Sett.hotkey = tmpHotkey
					If IsDlgButtonChecked(hWin, IDC_CHKUPDATES) = BST_UNCHECKED Then Sett.updates = 0 Else Sett.updates = 1
					If IsDlgButtonChecked(hWin, IDC_CHKAUTOLOAD) = BST_UNCHECKED Then Sett.autoload = 0 Else Sett.autoload = 1
					UpdateAccelerator(TranslateModifiers(HiByte(Sett.hotkey)) Or FVIRTKEY or FNOINVERT, LoByte(Sett.hotkey), IDM_PORTICULA)
					SendMessage(hWin, WM_CLOSE, 0, 0)
					
				Case IDC_PWD
					If HiWord(wParam) = EN_SETFOCUS AndAlso PassHash <> "" Then
						q = GetWindowTextLength(GetDlgItem(hWin, IDC_PWD))
						tmpStr = String(q, 0)
						GetWindowText(GetDlgItem(hWin, IDC_PWD), StrPtr(tmpStr), q+1)
						If tmpStr = dummyStr Then SetWindowText(GetDlgItem(hWin, IDC_PWD), @"")
					End If
					If HiWord(wParam) = EN_KILLFOCUS AndAlso PassHash <> "" AndAlso GetWindowTextLength(GetDlgItem(hWin, IDC_PWD)) = 0 Then SetWindowText(GetDlgItem(hWin, IDC_PWD), StrPtr(dummyStr))
					
				Case IDC_CREATEACC
					ShellExecute(hWin, @"Open" , StrPtr(fbpCreateAccUrl) , NULL, NULL, SW_SHOWNORMAL)
					
				Case IDC_UPDATE
					If tUpdate = 0 Then tUpdate = ThreadCreate(@UpdateThread, Cast(Any Ptr, 1))
					
			End Select
			
		Case Else
			Return FALSE
			
	End Select
	Return TRUE

End Function


Sub IndentComment(ByVal char As String,ByVal fUn As Boolean, ByVal editor As HWND)
	Dim ochrg As CHARRANGE
	Dim chrg As CHARRANGE
	Dim As Integer LnSt,LnEn,LnCnt,tmp,nmin,n,bm
	Dim buffer As String*128
	Const tabsize As Integer = 2
	Const expand As Integer = 0

	If (GetWindowLong(editor, GWL_STYLE) And STYLE_READONLY) <> 0 Then Exit Sub
	
	nmin=999
	SendMessage(editor,WM_SETREDRAW,FALSE,0)
	SendMessage(editor,REM_LOCKUNDOID,TRUE,0)
	SendMessage(editor,EM_EXGETSEL,0,Cast(LPARAM,@ochrg))
	chrg.cpMin=ochrg.cpMin
	chrg.cpMax=ochrg.cpMax
	SendMessage(editor,EM_HIDESELECTION,TRUE,0)
	LnSt=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMin)
	If chrg.cpMax>chrg.cpMin Then
		chrg.cpMax-=1
	EndIf
	LnEn=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMax)
	LnCnt=LnEn-LnSt
	If LnCnt Then
		ochrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
		ochrg.cpMax=SendMessage(editor,EM_LINEINDEX,LnEn,0)
		ochrg.cpMax=ochrg.cpMax+SendMessage(editor,EM_LINELENGTH,ochrg.cpMax,0)+1
	ElseIf ochrg.cpMin<>ochrg.cpMax Then
		If ochrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0) And ochrg.cpMax=SendMessage(editor,EM_LINEINDEX,LnEn+1,0) Then
			LnCnt=1
		EndIf
	EndIf
	Do While LnSt<=LnEn
		If fUn Then
			' Uncomment or Outdent
			If char=Chr(9) Then
				' Outdent
				chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
				chrg.cpMax=chrg.cpMin+1
				SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
				SendMessage(editor,EM_GETSELTEXT,0,Cast(LPARAM,@buffer))
				If buffer=Chr(9) Then
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,StrPtr("")))
					If lnCnt>0 Or chrg.cpMin<ochrg.cpMax Then
						ochrg.cpMax-=1
						If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
							ochrg.cpMin-=1
						EndIf
					EndIf
				Else
					tmp=tabsize
					While tmp
						chrg.cpMax=chrg.cpMin+tmp
						SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
						SendMessage(editor,EM_GETSELTEXT,0,Cast(LPARAM,@buffer))
						If buffer=Space(tmp) Then
							SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,StrPtr("")))
							If lnCnt>0 Or chrg.cpMax<=ochrg.cpMax Then
								ochrg.cpMax-=tmp
								If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
									ochrg.cpMin-=tmp
								EndIf
							ElseIf chrg.cpMax>ochrg.cpMax Then
								ochrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
								ochrg.cpMax=ochrg.cpMin
							EndIf
							Exit While
						EndIf
						tmp=tmp-1
					Wend
				EndIf
			Else
				' Uncomment
				buffer=Chr(127) & Chr(0)
				n=SendMessage(editor,EM_GETLINE,LnSt,Cast(LPARAM,@buffer))
				buffer[n]=0
				For tmp=0 To 127
					If buffer[tmp]<>VK_SPACE And buffer[tmp]<>VK_TAB And buffer[tmp]<>Asc("'") Then
						Exit For
					ElseIf buffer[tmp]=Asc("'") Then
						chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)+tmp
						chrg.cpMax=chrg.cpMin+1
						SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
						SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,StrPtr("")))
						If lnCnt>0 Or chrg.cpMin<ochrg.cpMax Then
							ochrg.cpMax-=1
							If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
								ochrg.cpMin-=1
							EndIf
						EndIf
						Exit For
					EndIf
				Next
			EndIf
		Else
			' Comment or Indent
			chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)
			chrg.cpMax=chrg.cpMin
			SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
			If char=Chr(9) Then
				' Indent
				If expand Then
					buffer=Space(tabsize)
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,@buffer))
					ochrg.cpMax+=tabsize
					If LnCnt=0 Then
						ochrg.cpMin+=tabsize
					EndIf
				Else
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,@char))
					ochrg.cpMax+=1
					If LnCnt=0 Then
						ochrg.cpMin+=1
					EndIf
				EndIf
			Else
				' Comment
				bm=SendMessage(editor,REM_GETBOOKMARK,LnSt,0)
				If bm=1 Or bm=2 Then
					SendMessage(editor,REM_SETBOOKMARK,LnSt,0)
					SendMessage(editor,REM_SETDIVIDERLINE,LnSt,FALSE)
				EndIf
				buffer=Chr(127) & Chr(0)
				n=SendMessage(editor,EM_GETLINE,LnSt,Cast(LPARAM,@buffer))
				buffer[n]=0
				n=0
				For tmp=0 To 127
					If buffer[tmp]=VK_SPACE Then
						n+=1
					ElseIf buffer[tmp]=VK_TAB Then
						n+=tabsize
						n=(n\tabsize)*tabsize
					ElseIf buffer[tmp]=0 Then
						n=999
						Exit For
					Else
						Exit For
					EndIf
				Next
				If n<nmin Then
					nmin=n
				EndIf
			EndIf
		EndIf
		LnSt=LnSt+1
	Loop
	If fUn=0 And char="'" Then
		' Comment
		chrg.cpMin=ochrg.cpMin
		chrg.cpMax=ochrg.cpMax
		LnSt=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMin)
		If chrg.cpMax>chrg.cpMin Then
			chrg.cpMax=chrg.cpMax-1
		EndIf
		LnEn=SendMessage(editor,EM_EXLINEFROMCHAR,0,chrg.cpMax)
		LnCnt=LnEn-LnSt
		Do While LnSt<=LnEn
			buffer=String(128,0)
			buffer=Chr(127) & Chr(0)
			n=SendMessage(editor,EM_GETLINE,LnSt,Cast(LPARAM,@buffer))
			buffer[n]=0
			n=0
			For tmp=0 To 127
				If n=nmin Then
					chrg.cpMin=SendMessage(editor,EM_LINEINDEX,LnSt,0)+tmp
					chrg.cpMax=chrg.cpMin
					SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@chrg))
					SendMessage(editor,EM_REPLACESEL,TRUE,Cast(LPARAM,@char))
					If lnCnt>0 Or chrg.cpMin<ochrg.cpMax Then
						ochrg.cpMax+=1
						If LnCnt=0 And chrg.cpMin<=ochrg.cpMin Then
							ochrg.cpMin+=1
						EndIf
					EndIf
					Exit For
				EndIf
				If buffer[tmp]=VK_SPACE Then
					n+=1
				ElseIf buffer[tmp]=VK_TAB Then
					n+=tabsize
					n=(n\tabsize)*tabsize
				ElseIf buffer[tmp]=0 Then
					Exit For
				EndIf
			Next
			LnSt=LnSt+1
		Loop
	EndIf
	SendMessage(editor,EM_EXSETSEL,0,Cast(LPARAM,@ochrg))
	SendMessage(editor,EM_HIDESELECTION,FALSE,0)
	SendMessage(editor,REM_LOCKUNDOID,FALSE,0)
	SendMessage(editor,WM_SETREDRAW,TRUE,0)
	SendMessage(editor,REM_REPAINT,0,0)
	SetFocus(editor)

End Sub





Function EditProc(ByVal hWin As HWND,ByVal uMsg As UINT,ByVal wParam As WPARAM,ByVal lParam As LPARAM) As Integer
	Dim pt As Point
	Dim chrg As CHARRANGE
	
	Select Case uMsg
		Case WM_CONTEXTMENU
			If lParam = -1 Then
				GetCaretPos(@pt)
				ClientToScreen(hWin, @pt)
				pt.x = pt.x+10
			Else
				pt.x = Cast(Short, LoWord(lParam))
				pt.y = Cast(Short, HiWord(lParam))
			EndIf
			TrackPopupMenu(GetSubMenu(hContextMenu,0), TPM_LEFTALIGN Or TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWinMenu, 0)
			Return 0
			
		Case WM_CHAR
			If SendMessage(GetParent(hWin),REM_GETMODE,0,0)=0 Then					' Mode Normal
				If wParam=VK_TAB Then																					' Indent / Outdent
					If (GetKeyState(VK_SHIFT) And &H80)<>0 Then
						IndentComment(Chr(9),TRUE, GetParent(hWin))
						Return 0
					Else
						SendMessage(GetParent(hWin), EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
						If chrg.cpMin <> chrg.cpMax Then
							IndentComment(Chr(9),FALSE, GetParent(hWin))
							Return 0
						End If
					EndIf
				EndIf
			End If
			
		Case WM_KEYUP
			If SendMessage(GetParent(hWin),REM_GETMODE,0,0)=0 Then					' Mode Normal
				If wParam = VK_F9 Then																				' Comment / Uncomment
					If (GetKeyState(VK_SHIFT) And &H80)<>0 Then
						IndentComment("'" & Chr(0), TRUE, GetParent(hWin))
						Return 0
					Else
						IndentComment("'" & Chr(0), FALSE, GetParent(hWin))
						Return 0
					EndIf
				End If
			End If
			
	End Select
	Return CallWindowProc(lpOldEditProc,hWin,uMsg,wParam,lParam)
End Function



Function GetCBSel(ByVal hWin As HWND) As PorticulaEntry Ptr
	Dim pi As PorticulaEntry Ptr
	Dim sel As Integer
	Dim item As COMBOBOXEXITEM
	
	MutexLock(mutexCB)
	
	sel = SendMessage(hWin, CB_GETCURSEL, 0, 0)
	If sel <> CB_ERR Then
		item.iItem = sel
		item.mask = CBEIF_LPARAM
		SendMessage(hWin, CBEM_GETITEM, 0, Cast(LPARAM, @item))
		pi = Cast(PorticulaEntry Ptr, item.lParam)
	End If
	
	MutexUnLock(mutexCB)
	
	Return pi
End Function


Function GetCBSelID(ByVal hWin As HWND) As Integer
	Dim pi As PorticulaEntry Ptr
	pi = GetCBSel(hWin)
	If pi = 0 Then Return -1
	Return pi->id
End Function

Sub FillCB(ByVal hWin As HWND, ByVal inet As Integer = 1)
	Dim item As COMBOBOXEXITEM
	Dim posA As Integer
	Dim posE As Integer
	Dim posA2 As Integer
	Dim posE2 As Integer
	Dim tmpPos As Integer
	Dim outp As String
	Dim tmpStr As String
	Dim sel As Integer
	Dim pi As PorticulaEntry Ptr
	Dim q As Integer
	Dim tmpUrl As URL = fbpApiUrl
			
	If inet <> 0 Then
		tmpUrl.Query = "action=listall&n=all"
		If getHTTP(tmpUrl, outp) <> "" Then
			MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
			Return
		End If
		If Left(outp, 5) = "ERROR" Then
			tmpStr = "Fehler beim Empfangen der NoPaste-Eintrge" & CRLF & outp
			MessageBox(hWin, StrPtr(tmpStr), @"Fehler", MB_OK Or MB_ICONERROR)
			Return
		End If
		
	End If
	
	sel = GetCBSelID(hWin)
	
	MutexLock(mutexCB)
	
	If inet <> 0 Then
	
		If @fbpList(0) <> 0 Then
			For q = LBound(fbpList) To UBound(fbpList)
				Delete(fbpList(q))
			Next
		End If
	
	End If
	
	SendMessage(hWin, CB_RESETCONTENT, 0, 0)
	
	item.iItem = 0
	item.mask = CBEIF_TEXT Or CBEIF_LPARAM Or CBEIF_IMAGE Or CBEIF_SELECTEDIMAGE
	item.pszText = @"< Neuer Eintrag >"
	item.lParam = 0
	item.iImage = 1
	item.iSelectedImage = item.iImage
	SendMessage(hWin, CBEM_INSERTITEM, 0, Cast(LPARAM, @item))
	
	If inet = 0 Then
		If @fbpList(0) <> 0 Then

			For q = LBound(fbpList) To UBound(fbpList)
				pi = fbpList(q)
				If pi = 0 Then Continue for					' prevent crash (should never be true)
				If Sett.onlyOwn <> 0 And pi->usern <> Username Then Continue For
				tmpStr = "[" + Str(pi->id) + "]  " + pi->title + "  [" + pi->usern + "]"
				item.iItem = -1
				item.mask = CBEIF_TEXT Or CBEIF_LPARAM Or CBEIF_IMAGE Or CBEIF_SELECTEDIMAGE
				item.pszText = StrPtr(tmpStr)
				item.lParam = Cast(LPARAM, pi)
				item.iImage = IIf(pi->usern = Username, 0, 2)
				item.iSelectedImage = item.iImage
				SendMessage(hWin, CBEM_INSERTITEM, 0, Cast(LPARAM, @item))
				
				If sel = pi->id Then
					curSel = SendMessage(hWin, CB_GETCOUNT, 0, 0) - 1
					SendMessage(hWin, CB_SETCURSEL, curSel, 0)
				End If
			Next
		End If
	Else
		posA = 1
		q = CountOcc(outp, Chr(10))
		ReDim fbpList(0 To q-1)
		q = 0
		Do
			posE = InStr(posA, outp, Chr(10))
			If posE <= 0 Then posE = Len(outp)+1
			If posA >= posE Then Exit Do
			
			pi = New PorticulaEntry
			
			posE2 = InStr(posA, outp, ";")
			pi->id = Val(Mid(outp, posA, posE2-posA))
			posA2 = posE2+1
			posE2 = InStr(posA2, outp, ";")
			pi->datet = UrlDecode(Mid(outp, posA2, posE2-posA2))
			posA2 = posE2+1
			posE2 = InStr(posA2, outp, ";")
			pi->title = UrlDecode(Mid(outp, posA2, posE2-posA2))
			posA2 = posE2+1
			posE2 = InStr(posA2, outp, ";")
			pi->sz = Val(Mid(outp, posA2, posE2-posA2))
			posA2 = posE2+1
			pi->usern = UrlDecode(Mid(outp, posA2, posE-posA2))
			
			fbpList(q) = pi
			
			posA = posE+1
			q += 1
			
			If Sett.onlyOwn <> 0 And pi->usern <> Username Then Continue Do
			
			tmpStr = "[" + Str(pi->id) + "]  " + pi->title + "  [" + pi->usern + "]"
			item.iItem = -1
			item.mask = CBEIF_TEXT Or CBEIF_LPARAM Or CBEIF_IMAGE Or CBEIF_SELECTEDIMAGE
			item.pszText = StrPtr(tmpStr)
			item.lParam = Cast(LPARAM, pi)
			item.iImage = IIf(pi->usern = Username, 0, 2)
			item.iSelectedImage = item.iImage
			SendMessage(hWin, CBEM_INSERTITEM, 0, Cast(LPARAM, @item))
			
			If sel = pi->id Then
				curSel = SendMessage(hWin, CB_GETCOUNT, 0, 0) - 1
				SendMessage(hWin, CB_SETCURSEL, curSel, 0)
			End If
			
		Loop
	End If
	
	If SendMessage(hWin, CB_GETCURSEL, 0, 0) = CB_ERR Then SendMessage(hWin, CB_SETCURSEL, 0, 0): curSel = 0
	
	MutexUnLock(mutexCB)
	
	UpdControls(GetParent(hWin))
	
End Sub

Sub FillCBThread(param As Any Ptr)
	FillCB(param, 1)
	tFillCB = 0
End Sub



Sub UpdControls(ByVal hWin As HWND)
	Dim pi As PorticulaEntry Ptr
	pi = GetCBSel(GetDlgItem(hWin, IDC_NOPASTE))
	If pi = 0 Then
		SetWindowText(GetDlgItem(hWin, IDC_SAVE), @"Hochladen")
		EnableWindow(GetDlgItem(hWin, IDC_COPYURL), FALSE)
		EnableWindow(GetDlgItem(hWin, IDC_BROWSER), FALSE)
		EnableWindow(GetDlgItem(hWin, IDC_SAVE), TRUE)
		EnableWindow(GetDlgItem(hWin, IDC_DELETE), FALSE)
		SendMessage(GetDlgItem(hWin, IDC_TITLE), EM_SETREADONLY, FALSE, 0)
		'SendMessage(GetDlgItem(hWin, IDC_RAEDIT), EM_SETREADONLY, FALSE, 0)
		SendMessage(GetDlgItem(hWin, IDC_RAEDIT), REM_READONLY, 0, FALSE)
		'SetWindowLong(GetDlgItem(hWin, IDC_RAEDIT), GWL_STYLE, GetWindowLong(GetDlgItem(hWin, IDC_RAEDIT), GWL_STYLE) And (Not STYLE_READONLY))
		Exit Sub
	End If
	SetWindowText(GetDlgItem(hWin, IDC_SAVE), @"Speichern")
	EnableWindow(GetDlgItem(hWin, IDC_COPYURL), TRUE)
	EnableWindow(GetDlgItem(hWin, IDC_BROWSER), TRUE)
	If pi->usern = Username Then
		EnableWindow(GetDlgItem(hWin, IDC_SAVE), TRUE)
		EnableWindow(GetDlgItem(hWin, IDC_DELETE), TRUE)
		SendMessage(GetDlgItem(hWin, IDC_TITLE), EM_SETREADONLY, FALSE, 0)
		'SendMessage(GetDlgItem(hWin, IDC_RAEDIT), EM_SETREADONLY, FALSE, 0)
		SendMessage(GetDlgItem(hWin, IDC_RAEDIT), REM_READONLY, 0, FALSE)
		'SetWindowLong(GetDlgItem(hWin, IDC_RAEDIT), GWL_STYLE, GetWindowLong(GetDlgItem(hWin, IDC_RAEDIT), GWL_STYLE) And (Not STYLE_READONLY))
	Else
		EnableWindow(GetDlgItem(hWin, IDC_SAVE), FALSE)
		EnableWindow(GetDlgItem(hWin, IDC_DELETE), FALSE)
		SendMessage(GetDlgItem(hWin, IDC_TITLE), EM_SETREADONLY, TRUE, 0)
		'SendMessage(GetDlgItem(hWin, IDC_RAEDIT), EM_SETREADONLY, TRUE, 0)
		SendMessage(GetDlgItem(hWin, IDC_RAEDIT), REM_READONLY, 0, TRUE)
		'SetWindowLong(GetDlgItem(hWin, IDC_RAEDIT), GWL_STYLE, GetWindowLong(GetDlgItem(hWin, IDC_RAEDIT), GWL_STYLE) Or STYLE_READONLY)
	End If
End Sub


Sub UpdMenu(ByVal hWin As HWND)
	Dim chrg as CHARRANGE
	Dim ena As Integer
	EnableMenuItem(hContextMenu, IDM_UNDO, MF_BYCOMMAND Or IIf(SendDlgItemMessage(hWin, IDC_RAEDIT, EM_CANUNDO, 0, 0), MF_ENABLED, MF_GRAYED))
	EnableMenuItem(hContextMenu, IDM_REDO, MF_BYCOMMAND Or IIf(SendDlgItemMessage(hWin, IDC_RAEDIT, EM_CANREDO, 0, 0), MF_ENABLED, MF_GRAYED))
	EnableMenuItem(hContextMenu, IDM_PASTE, MF_BYCOMMAND Or IIf(SendDlgItemMessage(hWin, IDC_RAEDIT, EM_CANPASTE, CF_TEXT, 0), MF_ENABLED, MF_GRAYED))
	SendDlgItemMessage(hWin, IDC_RAEDIT, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
	If chrg.cpMin = chrg.cpMax Then ena = MF_GRAYED Else ena = MF_ENABLED
	EnableMenuItem(hContextMenu, IDM_COPY, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_CUT, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_DELETE, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_BLOCKINDENT, MF_BYCOMMAND Or ena)
	EnableMenuItem(hContextMenu, IDM_BLOCKOUTDENT, MF_BYCOMMAND Or ena)
End Sub



Function CheckServer() As Integer
	Dim tmpStr As String
	Dim tmpUri As URL = fbpApiUrl
	tmpUri.Query = "action=apiversion"
	If getHTTP(tmpUri, tmpStr) <> "" Then Return 2
	If Left(tmpStr,1) <> "3" Then Return 3
	Return 1
End Function





Function PorticulaProc(byval hWin as HWND,byval uMsg as UINT,byval wParam as WPARAM,byval lParam as LPARAM) as integer
	Dim rc as RECT
	Dim tmpStr As String
	Dim tmpStr2 As String
	Dim q As Integer
	Dim w As Integer
	Dim sel As Integer
	Dim pi As PorticulaEntry Ptr
	'Dim cbi As COMBOBOXINFO
	'dim buff as zstring*260
	'dim lpFBNOTIFY as FBNOTIFY ptr
	'dim editstream as EDITSTREAM
	'dim hFile as HANDLE
	Dim hMem as HGLOBAL
	Dim chrg as CHARRANGE
	'dim nSize as integer
	Dim hMenuInsert As HMENU = 0
	Dim pt As POINT

	Select Case uMsg
		case WM_INITDIALOG
			MoveWindow(hWin, WinPos.left, WinPos.top, WinPos.right-WinPos.left, WinPos.bottom-WinPos.top, FALSE)
			
			lpOldEditProc = Cast(Any Ptr, SendMessage(GetDlgItem(hWin, IDC_RAEDIT), REM_SUBCLASS, 0, Cast(LPARAM, @EditProc)))
			hWinMenu = hWin
			
			SendDlgItemMessage(hWin, IDC_RAEDIT, REM_SETFONT, 0, Cast(LPARAM, @lpHandles->rafnt))
			SendDlgItemMessage(hWin, IDC_RAEDIT, REM_SETCOLOR, 0, Cast(LPARAM, lpData->lpFBCOLOR))
			SendDlgItemMessage(hWin, IDC_RAEDIT, REM_SELBARWIDTH, 10, 0)
			CheckDlgButton(GetDlgItem(hWin, IDC_RAEDIT), -2, TRUE)			'Show line numbers
			SendDlgItemMessage(hWin, IDC_RAEDIT, WM_COMMAND, -2, 0)
			CheckDlgButton(hWin, IDC_CHKOWN, IIf(Sett.onlyOwn <> 0, BST_CHECKED, BST_UNCHECKED))
			
			MutexLock(mutexApiVer)
			If ServerChecked = 0 Or ServerChecked = 2 Then ServerChecked = CheckServer()
			If ServerChecked = 2 Then MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
			If ServerChecked = 3 Then MessageBox(hWin, @("Unerwartete API-Version des fb:porticula Servers." + CRLF + "Dieses Programm ist mit dieser Version nicht kompatibel." + CRLF + "Bitte verwenden Sie eine aktuellere Version dieses Programms."), @"Fehler", MB_OK Or MB_ICONERROR)
			If ServerChecked <> 1 Then SendMessage(hWin, WM_CLOSE, 0, 0)
			MutexUnLock(mutexApiVer)
			
			SendDlgItemMessage(hWin, IDC_NOPASTE, CBEM_SETIMAGELIST, 0, Cast(LPARAM, hIml))
			FillCB(GetDlgItem(hWin, IDC_NOPASTE), 0)
			'FillCB(GetDlgItem(hWin, IDC_NOPASTE), IIf(Sett.AutoLoad <> 0, 1, 0))
			MutexLock(mutexCB)
			SendDlgItemMessage(hWin, IDC_NOPASTE, CB_SETCURSEL, 0, 0)
			curSel = 0
			MutexUnLock(mutexCB)
			'UpdControls(hWin)
			If Sett.autoload then If tFillCB = 0 Then tFillCB = ThreadCreate(@FillCBThread, Cast(Any Ptr, GetDlgItem(hWin, IDC_NOPASTE)))
			
			If lpHandles->hred <> 0 AndAlso lpHandles->hred <> lpHandles->hres Then
				q = SendMessage(lpHandles->hred, WM_GETTEXTLENGTH, 0, 0)
				If q > 0 Then
					SendMessage(lpHandles->hred, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
					if chrg.cpMin=chrg.cpMax then
						q += 1
						hMem = GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT, q)
						SendMessage(lpHandles->hred, WM_GETTEXT, q-1, Cast(LPARAM, hMem))
					else
						q = chrg.cpMax-chrg.cpMin+1
						hMem = GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT, q)
						SendMessage(lpHandles->hred, EM_GETSELTEXT, 0, Cast(LPARAM, hMem))
					endif
					SendDlgItemMessage(hWin, IDC_RAEDIT, WM_SETTEXT, 0, Cast(LPARAM, hMem))
					GlobalFree(hMem)
					SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
				End If
			End If
			
			
			'cbi.cbSize = SizeOf(COMBOBOXINFO)
			
		case WM_CLOSE
			If SendDlgItemMessage(hWin, IDC_RAEDIT, EM_GETMODIFY, 0, 0) <> 0 OrElse SendDlgItemMessage(hWin, IDC_TITLE, EM_GETMODIFY, 0, 0) <> 0 Then _
				If MessageBox(hWin, @"Wollen Sie Ihre nderungen wirklich verwerfen?", @"nderungen verwerfen?", MB_YESNOCANCEL Or MB_ICONQUESTION) <> IDYES Then Exit Select
			GetWindowRect(hWin, @WinPos)
			hWinMenu = 0
			If hMenuInsert <> 0 Then DestroyMenu(hMenuInsert)
			EndDialog(hWin, 0)
			
		case WM_COMMAND
			Select Case LoWord(wParam)
				Case IDC_CLOSE
					SendMessage(hWin, WM_CLOSE, 0, 0)
					
				Case IDC_SAVE
					'q = SendDlgItemMessage(hWin, IDC_NOPASTE, CB_GETCURSEL, 0, 0)
					sel = GetCBSelID(GetDlgItem(hWin, IDC_NOPASTE))
					If sel = -1 Then
						fbpApiUrl.Query = "action=newcode&username=" + URLEncode(Username) + "&pwhash=" + URLEncode(PassHash)
					Else
						fbpApiUrl.Query = "action=savecode&id=" + Str(sel) + "&username=" + URLEncode(Username) + "&pwhash=" + URLEncode(PassHash)
					End If
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_TITLE)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(tmpStr), Len(tmpStr)+1)
					If Trim(tmpStr) = "" Then MessageBox(hWin, @"Bitte geben Sie einen Titel ein!", @"Fehler", MB_OK Or MB_ICONWARNING) : Exit Select
					tmpStr2 = "Titel=" & URLEncode(tmpStr)
					tmpStr = String(GetWindowTextLength(GetDlgItem(hWin, IDC_RAEDIT)), 0)
					GetWindowText(GetDlgItem(hWin, IDC_RAEDIT), StrPtr(tmpStr), Len(tmpStr))		'RAEdit does not include null byte in length
					If Trim(tmpStr) = "" Then MessageBox(hWin, @"Bitte geben Sie einen Quellcode ein!", @"Fehler", MB_OK Or MB_ICONWARNING) : Exit Select
					tmpStr2 &= "&Quelltext=" & URLEncode(tmpStr)
					If Trim(Username) = "" Or Len(Trim(PassHash)) <> 32 Then
						If MessageBox(hWin, @"Bitte geben Sie zuvor eine gltige Kombination aus Benutzername und Passwort an!", @"Fehler bei Authenzifierung", MB_OKCANCEL Or MB_ICONWARNING) <> IDOK Then Exit Select
						SendMessage(hWin, WM_COMMAND, MAKELONG(IDC_SETTINGS, BN_CLICKED), Cast(LPARAM, GetDlgItem(hWin, IDC_SETTINGS)))
						If Trim(Username) = "" Or Len(Trim(PassHash)) <> 32 Then Exit Select
					End If
					If postHTTP(fbpApiUrl, tmpStr2,, tmpStr) <> "" Then
						MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					If Left(tmpStr,7)  <> "SUCCESS" Then
						tmpStr = "Fehler beim Speichern des Eintrags" & CRLF & tmpStr
						MessageBox(hWin, StrPtr(tmpStr), @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					MessageBox(hWin, @"Eintrag erfolgreich gespeichert!", @"Eintrag gespeichert!", MB_OK Or MB_ICONINFORMATION)
					If sel = -1 Then
						MutexLock(mutexCB)
						If @fbpList(0) <> 0 Then
							ReDim Preserve fbpList(LBound(fbpList) To UBound(fbpList)+1)
							For q = UBound(fbpList) To LBound(fbpList)+1 Step -1
								fbpList(q) = fbpList(q-1)
							Next
						Else
							ReDim fbpList(0 To 0)
						End If
						pi = New PorticulaEntry
						pi->id = Val(Mid(tmpStr, 9))
						pi->usern = Username
						fbpList(0) = pi
						MutexUnLock(mutexCB)
					Else
						pi = GetCBSel(GetDlgItem(hWin, IDC_NOPASTE))
					End If
					If pi <> 0 Then
						pi->datet = Date & " " & Time
						pi->title = String(GetWindowTextLength(GetDlgItem(hWin, IDC_TITLE)), 0)
						GetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(pi->title), Len(pi->title)+1)
						pi->sz = GetWindowTextLength(GetDlgItem(hWin, IDC_RAEDIT))
					End If
					FillCB(GetDlgItem(hWin, IDC_NOPASTE), 0)
					SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
					If sel = -1 Then
						MutexLock(mutexCB)
						SendDlgItemMessage(hWin, IDC_NOPASTE, CB_SETCURSEL, 1, 0)
						curSel = 1
						MutexUnLock(mutexCB)
						UpdControls(hWin)
					End If
					
				Case IDC_DELETE
					If MessageBox(hWin, @"Wollen Sie den ausgewhlten Eintrag wirklich lschen?", @"Lschen besttigen", MB_YESNOCANCEL Or MB_ICONQUESTION) <> IDYES Then Exit Select
					pi = GetCBSel(GetDlgItem(hWin, IDC_NOPASTE))
					If pi = 0 Then
						MessageBox(hWin, @"Kein oder ungltiges Element ausgewhlt", @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					If Trim(Username) = "" Or Len(Trim(PassHash)) <> 32 Then
						If MessageBox(hWin, @"Bitte geben Sie zuvor eine gltige Kombination aus Benutzername und Passwort an!", @"Fehler bei Authenzifierung", MB_OKCANCEL Or MB_ICONWARNING) <> IDOK Then Exit Select
						SendMessage(hWin, WM_COMMAND, MAKELONG(IDC_SETTINGS, BN_CLICKED), Cast(LPARAM, GetDlgItem(hWin, IDC_SETTINGS)))
						If Trim(Username) = "" Or Len(Trim(PassHash)) <> 32 Then Exit Select
					End If
					sel = pi->id
					fbpApiUrl.Query = "action=delete&id=" + Str(sel) + "&username=" + URLEncode(Username) + "&pwhash=" + URLEncode(PassHash)
					If getHTTP(fbpApiUrl, tmpStr) <> "" Then
						MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					If tmpStr <> "SUCCESS" Then
						tmpStr = "Fehler beim Lschen des Eintrags" & CRLF & tmpStr
						MessageBox(hWin, StrPtr(tmpStr), @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					MessageBox(hWin, @"Eintrag erfolgreich gelscht!", @"Eintrag gelscht!", MB_OK Or MB_ICONINFORMATION)
					SetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(""))
					SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_RAEDIT, WM_SETTEXT, 0, Cast(LPARAM, StrPtr("")))
					SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
					MutexLock(mutexCB)
					Delete(pi)
					If UBound(fbpList)-LBound(fbpList) = 0 Then
						Erase fbpList
					Else
						For w = LBound(fbpList) To UBound(fbpList)
							If fbpList(w)->id = pi->id Then Exit For
						Next
						For q = w+1 To UBound(fbpList)
							fbpList(q-1) = fbpList(q)
						Next
						ReDim Preserve fbpList(LBound(fbpList) To UBound(fbpList)-1)
					End If
					MutexUnLock(mutexCB)
					FillCB(GetDlgItem(hWin, IDC_NOPASTE), 0)
					MutexLock(mutexCB)
					SendDlgItemMessage(hWin, IDC_NOPASTE, CB_SETCURSEL, 0, 0)
					curSel = 0
					MutexUnLock(mutexCB)
					UpdControls(hWin)
					
				Case IDC_ABOUT
					fbpApiUrl.Query = "action=info"
					If getHTTP(fbpApiUrl, tmpStr) = "" Then
						tmpStr = "fb:porticula NoPaste Plugin fr FBedit" + CRLF + "(c) 2011 Stefan Wurzinger" + CRLF + "Version " + prgVersion + CRLF + CRLF + tmpStr
						MessageBox(hWin, StrPtr(tmpStr), @"ber fb:porticula NoPaste", MB_OK)
					Else
						MessageBox(hWin, @"Fehler beim Abrufen der Information", @"Fehler", MB_OK Or MB_ICONERROR)
					EndIf
					
				Case IDC_SETTINGS
					DialogBoxParam(hInstance, Cast(ZString Ptr, IDD_SETTINGS), hWin, @SettingsProc, NULL)
					FillCB(GetDlgItem(hWin, IDC_NOPASTE), 0)
					'UpdControls(hWin)
					
				Case IDC_REFRESH
					'FillCB(GetDlgItem(hWin, IDC_NOPASTE), 1)
					If tFillCB = 0 Then tFillCB = ThreadCreate(@FillCBThread, Cast(Any Ptr, GetDlgItem(hWin, IDC_NOPASTE)))
					'UpdControls(hWin)
					
				Case IDC_NOPASTE
					Select Case HiWord(wParam)
						Case CBN_SELCHANGE
							MutexLock(mutexCB)
							q = SendDlgItemMessage(hWin, IDC_NOPASTE, CB_GETCURSEL, 0, 0)
							MutexUnLock(mutexCB)
							If q = curSel Then Exit Select
							sel = GetCBSelID(GetDlgItem(hWin, IDC_NOPASTE))
							If SendDlgItemMessage(hWin, IDC_RAEDIT, EM_GETMODIFY, 0, 0) <> 0 OrElse SendDlgItemMessage(hWin, IDC_TITLE, EM_GETMODIFY, 0, 0) <> 0 Then
								If MessageBox(hWin, @"Wollen Sie Ihre nderungen wirklich verwerfen?", @"nderungen verwerfen?", MB_YESNOCANCEL Or MB_ICONQUESTION) <> IDYES Then
									MutexLock(mutexCB)
									SendDlgItemMessage(hWin, IDC_NOPASTE, CB_SETCURSEL, curSel, 0)
									MutexUnLock(mutexCB)
									Exit Select
								End If
							End If
							If sel <> -1 Then
								fbpApiUrl.Query = "action=download&id=" + Str(sel)
								If getHTTP(fbpApiUrl, tmpStr) <> "" Then
									MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
									MutexLock(mutexCB)
									SendDlgItemMessage(hWin, IDC_NOPASTE, CB_SETCURSEL, curSel, 0)
									MutexUnLock(mutexCB)
									Exit Select
								End If
								If Left(tmpStr,5) = "ERROR" Then
									tmpStr = "Fehler beim Herunterladen des Eintrags" & CRLF & tmpStr
									MessageBox(hWin, StrPtr(tmpStr), @"Fehler", MB_OK Or MB_ICONERROR)
									MutexLock(mutexCB)
									SendDlgItemMessage(hWin, IDC_NOPASTE, CB_SETCURSEL, curSel, 0)
									MutexUnLock(mutexCB)
									Exit Select
								End If
							End If
							curSel = q
							If sel <> -1 Then
								w = FindOcc(tmpStr, Chr(10), 3)
								q = InStr(w+1,tmpStr, Chr(10))
								If w > 0 Then tmpStr2 = UrlDecode(Mid(tmpStr, w+1, q-w-1)) Else tmpStr = ""
								SetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(tmpStr2))
								If w > 0 AndAlso q > 0 Then tmpStr2 = UrlDecode(Mid(tmpstr, q+1)) Else tmpStr = ""
								SendDlgItemMessage(hWin, IDC_RAEDIT, WM_SETTEXT, 0, Cast(LPARAM, StrPtr(tmpStr2)))
							Else
								SetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(""))
								SendDlgItemMessage(hWin, IDC_RAEDIT, WM_SETTEXT, 0, Cast(LPARAM, StrPtr("")))
							End If
							SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
							SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
							UpdControls(hWin)
					End Select
					
				Case IDC_CHKOWN
					If HiWord(wParam) = BN_CLICKED Then
						q = IIf(IsDlgButtonChecked(hWin, IDC_CHKOWN) = BST_UNCHECKED, 0, 1)
						w = 0
						If q = Sett.onlyOwn Then Exit Select
						If Sett.onlyOwn = 0 Then
							pi = GetCBSel(GetDlgItem(hWin, IDC_NOPASTE))
							If pi <> 0 AndAlso pi->usern <> Username Then
								w = 1
								If SendDlgItemMessage(hWin, IDC_RAEDIT, EM_GETMODIFY, 0, 0) <> 0 OrElse SendDlgItemMessage(hWin, IDC_TITLE, EM_GETMODIFY, 0, 0) <> 0 Then
									If MessageBox(hWin, @"Wollen Sie Ihre nderungen wirklich verwerfen?", @"nderungen verwerfen?", MB_YESNOCANCEL Or MB_ICONQUESTION) <> IDYES Then
										CheckDlgButton(hWin, IDC_CHKOWN, IIf(Sett.onlyOwn <> 0, BST_CHECKED, BST_UNCHECKED))
										Exit Select
									End If
								End If
							End If
						End If
						Sett.onlyOwn = q
						If w = 1 Then
							SendDlgItemMessage(hWin, IDC_NOPASTE, CB_SETCURSEL, 0, 0)
							CurSel = 0
							SetWindowText(GetDlgItem(hWin, IDC_TITLE), StrPtr(""))
							SendDlgItemMessage(hWin, IDC_RAEDIT, WM_SETTEXT, 0, Cast(LPARAM, StrPtr("")))
							SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
							SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
							UpdControls(hWin)
						End If
						FillCB(GetDlgItem(hWin, IDC_NOPASTE), 0)
					End If
					
				Case IDC_COPYURL
					sel = GetCBSelID(GetDlgItem(hWin, IDC_NOPASTE))
					If sel = -1 Then
						MessageBox(hWin, @"Kein oder ungltiges Element ausgewhlt", @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					fbpApiUrl.Query = "action=id2url&id=" + Str(sel)
					If getHTTP(fbpApiUrl, tmpStr) <> "" Then
						MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					If Left(tmpStr,5) = "ERROR" Then
						tmpStr = "Fehler beim Ermitteln der URL" & CRLF & tmpStr
						MessageBox(hWin, StrPtr(tmpStr), @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					If SetClipboardText(tmpStr, hWin) <> 0 Then MessageBox(hWin, @"Fehler beim Kopieren in die Zwischenablage", @"Fehler", MB_OK Or MB_ICONERROR)
					
				Case IDC_BROWSER
					sel = GetCBSelID(GetDlgItem(hWin, IDC_NOPASTE))
					If sel = -1 Then
						MessageBox(hWin, @"Kein oder ungltiges Element ausgewhlt", @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					fbpApiUrl.Query = "action=id2url&id=" + Str(sel)
					If getHTTP(fbpApiUrl, tmpStr) <> "" Then
						MessageBox(hWin, @"Fehler beim Verbindungsaufbau", @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					If Left(tmpStr,5) = "ERROR" Then
						tmpStr = "Fehler beim Ermitteln der URL" & CRLF & tmpStr
						MessageBox(hWin, StrPtr(tmpStr), @"Fehler", MB_OK Or MB_ICONERROR)
						Exit Select
					End If
					ShellExecute(hWin, @"Open" , StrPtr(tmpStr) , NULL, NULL, SW_SHOWNORMAL)
					
				Case IDC_INSERT
					q = SendDlgItemMessage(hWin, IDC_RAEDIT, WM_GETTEXTLENGTH, 0, 0)
					If q = 0 Then MessageBox(hWin, @"Kein Quelltext vorhanden!", @"Fehler", MB_OK Or MB_ICONWARNING) : Exit Select
					
					If hMenuInsert <> 0 Then DestroyMenu(hMenuInsert)
					hMenuInsert = CreatePopupMenu()
					AppendMenu(hMenuInsert, MF_STRING, IDM_NEWDOC, @"Neues Dokument")
					AppendMenu(hMenuInsert, MF_STRING, IDM_CLIPBOARD, @"Zwischenablage")
					If lpHandles->hred <> 0 AndAlso lpHandles->hred <> lpHandles->hres Then
						SendMessage(lpHandles->hred, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
						If chrg.cpMin <> chrg.cpMax Then
							AppendMenu(hMenuInsert, MF_SEPARATOR, 0, 0)
							AppendMenu(hMenuInsert, MF_STRING, IDM_SELBEFORE, @"Vor Auswahl")
							AppendMenu(hMenuInsert, MF_STRING, IDM_SELAFTER, @"Nach Auswahl")
							AppendMenu(hMenuInsert, MF_STRING, IDM_SELREPLACE, @"Auswahl ersetzen")
						Else
							AppendMenu(hMenuInsert, MF_STRING, IDM_CURSOR, @"An Cursorposition")
						EndIf
						AppendMenu(hMenuInsert, MF_SEPARATOR, 0, 0)
						AppendMenu(hMenuInsert, MF_STRING, IDM_DOCTOP, @"Am Dokumentbeginn")
						AppendMenu(hMenuInsert, MF_STRING, IDM_DOCBOTTOM, @"Am Dokumentende")
						AppendMenu(hMenuInsert, MF_STRING, IDM_DOCREPLACE, @"Inhalt ersetzen")
					EndIf
					pt.x = 0
					pt.y = 0
					ClientToScreen(GetDlgItem(hWin, IDC_INSERT), @pt)
					sel = TrackPopupMenuEx(hMenuInsert, TPM_RETURNCMD Or TPM_BOTTOMALIGN, pt.x, pt.y, hWin, 0)
					
					If sel = 0 Then Exit Select
					
					'if lpHandles->hred = 0 OrElse lpHandles->hred = lpHandles->hres Then
					'	MessageBox(hWin, @"In das aktuelle Fenster konnte kein Quellcode eingefgt werden!", @"Fehler", MB_OK Or MB_ICONWARNING)
					'	Exit Select
					'End If
					
					SendDlgItemMessage(hWin, IDC_RAEDIT, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
					if chrg.cpMin=chrg.cpMax then
						q += 1
						hMem = GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT, q)
						SendDlgItemMessage(hWin, IDC_RAEDIT, WM_GETTEXT, q-1, Cast(LPARAM,hMem))
					else
						q = chrg.cpMax-chrg.cpMin+1
						hMem = GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT, q)
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_GETSELTEXT, 0, Cast(LPARAM,hMem))
					EndIf
					
					If sel = IDM_CURSOR Or sel = IDM_SELREPLACE Then SendMessage(lpHandles->hred, EM_REPLACESEL, TRUE, Cast(LPARAM, hMem))
					If sel = IDM_DOCREPLACE Then SendMessage(lpHandles->hred, WM_SETTEXT, TRUE, Cast(LPARAM, hMem))
					If sel = IDM_CLIPBOARD Then SetClipboardTextZ(Cast(ZString Ptr, hMem), q-1, hWin)
					If sel = IDM_DOCTOP Then
						chrg.cpMin = 0
						chrg.cpMax = 0
						SendMessage(lpHandles->hred, EM_EXSETSEL, 0, Cast(LPARAM, @chrg))
						SendMessage(lpHandles->hred, EM_REPLACESEL, TRUE, Cast(LPARAM, hMem))
					EndIf
					If sel = IDM_DOCBOTTOM Then
						chrg.cpMin = -1
						chrg.cpMax = -1
						SendMessage(lpHandles->hred, EM_EXSETSEL, 0, Cast(LPARAM, @chrg))
						SendMessage(lpHandles->hred, EM_REPLACESEL, TRUE, Cast(LPARAM, hMem))
					EndIf
					If sel = IDM_SELBEFORE Then
						SendMessage(lpHandles->hred, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
						chrg.cpMax = chrg.cpMin
						SendMessage(lpHandles->hred, EM_EXSETSEL, 0, Cast(LPARAM, @chrg))
						SendMessage(lpHandles->hred, EM_REPLACESEL, TRUE, Cast(LPARAM, hMem))
					EndIf
					If sel = IDM_SELAFTER Then
						SendMessage(lpHandles->hred, EM_EXGETSEL, 0, Cast(LPARAM, @chrg))
						chrg.cpMin = chrg.cpMax
						SendMessage(lpHandles->hred, EM_EXSETSEL, 0, Cast(LPARAM, @chrg))
						SendMessage(lpHandles->hred, EM_REPLACESEL, TRUE, Cast(LPARAM, hMem))
					EndIf
					If sel = IDM_NEWDOC Then
						SendMessage(lpHandles->hwnd, WM_COMMAND, MAKEWPARAM(IDM_FILE_NEW, 0), 0)
						SendMessage(lpHandles->hred, WM_SETTEXT, 0, Cast(LPARAM, hMem))
					EndIf
					
					GlobalFree(hMem)
					SendDlgItemMessage(hWin, IDC_TITLE, EM_SETMODIFY, FALSE, 0)
					SendDlgItemMessage(hWin, IDC_RAEDIT, EM_SETMODIFY, FALSE, 0)
					SendMessage(hWin,WM_CLOSE,0,0)
					
					
				Case IDM_UNDO
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_UNDO, 0, 0)
					End If
					
				Case IDM_REDO
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_REDO, 0, 0)
					End If
					
				Case IDM_CUT
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, WM_CUT, 0, 0)
						'SetFocus(GetDlgItem(hWin, IDC_RAEDIT))
						'keybd_event(VK_CONTROL, 0, 0, 0)
						'keybd_event(VK_X, 0, 0, 0)
						'keybd_event(VK_X, 0, KEYEVENTF_KEYUP, 0)
						'keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0)
					End If
				
				Case IDM_COPY
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, WM_COPY, 0, 0)
					End If
				
				Case IDM_PASTE
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, WM_PASTE, 0, 0)
					End If
				
				Case IDM_DELETE
					If HiWord(wParam) = 0 Then
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_REPLACESEL, TRUE, 0)
					End If
				
				Case IDM_SELECTALL
					If HiWord(wParam) = 0 Then
						chrg.cpMin = 0
						chrg.cpMax = -1
						SendDlgItemMessage(hWin, IDC_RAEDIT, EM_EXSETSEL, 0, Cast(LPARAM, @chrg))
					End If
					
				Case IDM_BLOCKCOMMENT
						IndentComment("'" & Chr(0), FALSE, GetDlgItem(hWin, IDC_RAEDIT))
							
				Case IDM_BLOCKUNCOMMENT
						IndentComment("'" & Chr(0), TRUE, GetDlgItem(hWin, IDC_RAEDIT))
					
				Case IDM_BLOCKINDENT
							IndentComment(Chr(9),FALSE, GetDlgItem(hWin, IDC_RAEDIT))
					
				Case IDM_BLOCKOUTDENT
						IndentComment(Chr(9),TRUE, GetDlgItem(hWin, IDC_RAEDIT))
					
			End Select
			
		Case WM_SIZE
			GetClientRect(hWin, @rc)
			
			MoveWindow(GetDlgItem(hWin, IDC_RAEDIT), rc.left + 9, rc.top + 68, rc.right - rc.left + -18, rc.bottom - rc.top + -107, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_ABOUT), rc.left + 9, rc.bottom + -34, 104, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SETTINGS), rc.left + 118, rc.bottom + -34, 86, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_SAVE), rc.right + -322, rc.bottom + -34, 86, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_DELETE), rc.right + -231, rc.bottom + -34, 63, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_CLOSE), rc.right + -91, rc.bottom + -34, 82, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_NOPASTE), rc.left + 54, rc.top + 10, rc.right - rc.left + -263, 375, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_TITLE), rc.left + 54, rc.top + 39, rc.right - rc.left + -263, 20, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_REFRESH), rc.right + -113, rc.top + 8, 104, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_CHKOWN), rc.right + -199, rc.top + 13, 72, 15, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_COPYURL), rc.right + -204, rc.top + 36, 86, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_BROWSER), rc.right + -113, rc.top + 36, 104, 24, FALSE)
			MoveWindow(GetDlgItem(hWin, IDC_INSERT), rc.right + -163, rc.bottom + -34, 63, 24, FALSE)
			
			InvalidateRect(hWin, @rc, TRUE)
			
			'q = (rc.bottom - rc.top) / 2
			'If q < 300 Then q = 300
			'GetComboBoxInfo(hWin, @cbi)
			'GetClientRect(cbi.hwndList, @rc)
			'SetWindowPos(cbi.hwndList, HWND_TOP, 0, 0, rc.right - rc.left + 1, q, SWP_NOMOVE Or SWP_NOZORDER)
			
			
		Case WM_INITMENUPOPUP
			If wParam = hContextMenu Then UpdMenu(hWin)
			
		Case Else
			Return FALSE
			
	End Select
	Return TRUE
	
End Function

'param = 1 - Alle MessageBoxes anzeigen; param = 0 - Nur Update-Meldung
Sub UpdateThread(param As Any Ptr)
	
	Dim Daten As XML
	Dim xmlnode As XML Ptr
	Dim xmlnode2 As XML Ptr
	Dim tmpStr As String
	
	If getHTTP(prgUpdateUrl, tmpStr) <> "" Then
		If param = 1 Then MessageBox(lpHandles->hwnd, @"Fehler beim Verbindungsaufbau zum Update-Server!", @"fb:porticual Plugin - Fehler", MB_OK Or MB_ICONERROR)
		Exit Sub
	End If
	If Daten.Parse(tmpStr) <> 0 Then
		If param = 1 Then MessageBox(0, @"Fehler beim Analysieren der Update-Daten (Ungltige XML Daten)!", @"fb:porticual Plugin - Fehler", MB_OK Or MB_ICONERROR)
		Exit Sub
	End If
	xmlnode = Daten.GetSubTag("version")
	If xmlnode = 0 Then
		If param = 1 Then MessageBox(0, @"Fehler beim Analysieren der Update-Daten (Keine Versionsnummer gefunden)!", @"fb:porticual Plugin - Fehler", MB_OK Or MB_ICONERROR)
		Exit Sub
	End If
	xmlnode2 = Daten.GetSubTag("url")
	If prgVersion <> xmlnode->Daten Then
		If xmlnode2 = 0 Then
			tmpStr = "Fr Ihr fb:porticula Plugin ist ein Update verfgbar." + CRLF + CRLF + "Sie verwenden derzeit Version " + prgVersion + " whrend bereits Version " + xmlnode->Daten + " existiert." + CRLF + CRLF + "Bitte aktualisieren Sie das Programm auf die aktuelle Version," + CRLF + "um eine zuverlssige Funktionsweise weiterhin gewhrleisten zu knnen."
			MessageBox(lpHandles->hwnd, StrPtr(tmpStr), @"fb:porticual Plugin - Update verfgbar", MB_OK Or MB_ICONINFORMATION)
		Else
			tmpStr = "Fr Ihr fb:porticula Plugin ist ein Update verfgbar." + CRLF + CRLF + "Sie verwenden derzeit Version " + prgVersion + " whrend bereits Version " + xmlnode->Daten + " existiert." + CRLF + CRLF + "Bitte aktualisieren Sie das Programm auf die aktuelle Version," + CRLF + "um eine zuverlssige Funktionsweise weiterhin gewhrleisten zu knnen." + CRLF + CRLF + "Wollen Sie die Projektseite jetzt ffnen, um weitere Informationen zu erhalten?"
			If MessageBox(lpHandles->hwnd, StrPtr(tmpStr), @"fb:porticual Plugin - Update verfgbar", MB_YESNO Or MB_ICONQUESTION) = IDYES Then _
				ShellExecute(lpHandles->hwnd, @"open" , StrPtr(xmlnode2->Daten) , NULL, NULL, SW_SHOWNORMAL)
		End If
	Else
		If param = 1 Then MessageBox(lpHandles->hwnd, @"Ihre Version des fb:porticula Plugins ist auf dem aktuellen Stand", @"fb:porticual Plugin", MB_OK Or MB_ICONINFORMATION)
	End If
	
	If ServerChecked = 0 Or ServerChecked = 2 Then
		MutexLock(mutexApiVer)
		ServerChecked = CheckServer()
		MutexUnLock(mutexApiVer)
	EndIf
	
	
	tUpdate = 0
	
End Sub



Function InstallDll CDECL alias "InstallDll" (byval hWin as HWND,byval hInst as HINSTANCE) as ADDINHOOKS ptr EXPORT

	hInstance = hInst
	lpHandles = Cast(ADDINHANDLES ptr, SendMessage(hWin, AIM_GETHANDLES, 0, 0))
	lpData = Cast(ADDINDATA ptr, SendMessage(hWin, AIM_GETDATA, 0, 0))
	lpFunctions = Cast(ADDINFUNCTIONS ptr, SendMessage(hWin,AIM_GETFUNCTIONS, 0, 0))
	
	IDM_PORTICULA = SendMessage(hWin, AIM_GETMENUID, 0, 0)
	IDM_SETTINGS = SendMessage(hWin, AIM_GETMENUID, 0, 0)
	AddToMenu(IDM_PORTICULA, IDM_TOOLS, "fb:porticula NoPaste")
	AddToMenu(IDM_SETTINGS, IDM_OPTIONS, "fb:porticula Optionen")
	
	hContextMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_CONTEXTMENU))
	'AppendMenu(lpHandles->hcontextmenu, MF_POPUP, hContextMenu, 0)
	'AppendMenu(lpHandles->hcontextmenu, MF_POPUP Or MF_STRING, hContextMenu, @"test")
	
	lpFunctions->LoadFromIni("Porticula", "WinPos", "4444", @WinPos, FALSE)
	AuthOpt.usern = Allocate(50)
	AuthOpt.passhash = Allocate(32+1)
	*AuthOpt.usern = ""
	*AuthOpt.passhash = ""
	lpFunctions->LoadFromIni("Porticula", "FBP_Auth", "00", @AuthOpt, FALSE)
	Username = *AuthOpt.usern
	PassHash = *AuthOpt.passhash
	DeAllocate(AuthOpt.usern)
	DeAllocate(AuthOpt.passhash)
	lpFunctions->LoadFromIni("Porticula", "Settings", "4444", @Sett, FALSE)
	
	UpdateAccelerator(TranslateModifiers(HiByte(Sett.hotkey)) Or FVIRTKEY or FNOINVERT, LoByte(Sett.hotkey), IDM_PORTICULA)

	netStart()
	If Sett.updates <> 0 Then If tUpdate = 0 Then tUpdate = ThreadCreate(@UpdateThread)
	mutexCB = MutexCreate()
	mutexApiVer = MutexCreate()
	
	Dim hBmp As HBITMAP
	hIml = ImageList_Create(16, 16, ILC_COLOR24 Or ILC_MASK, 3, 0)
	hBmp = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_ICONS))
	ImageList_AddMasked(hIml, hBmp, &HFF00FF)
	DeleteObject(hBmp)
	
	Dim icex As InitCommonControlsEx
	icex.dwSize = sizeof(INITCOMMONCONTROLSEX)
	icex.dwICC = ICC_USEREX_CLASSES
	InitCommonControlsEx(@icex)
	
	hooks.hook1=HOOK_COMMAND or HOOK_CLOSE
	hooks.hook2=0
	hooks.hook3=0
	hooks.hook4=0
	return @hooks

End Function

Function DllFunction CDECL alias "DllFunction" (byval hWin as HWND,byval uMsg as UINT,byval wParam as WPARAM,byval lParam as LPARAM) as bool EXPORT
	Select Case uMsg
		Case AIM_COMMAND
		
			If LoWord(wParam) = IDM_PORTICULA Then
				DialogBoxParam(hInstance, Cast(ZString Ptr, IDD_PORTICULA), hWin, @PorticulaProc, NULL)
			EndIf
			If LoWord(wParam) = IDM_SETTINGS Then
				DialogBoxParam(hInstance, Cast(ZString Ptr, IDD_SETTINGS), hWin, @SettingsProc, NULL)
			EndIf
						
		Case AIM_CLOSE
			netStop()
			lpFunctions->SaveToIni("Porticula", "WinPos", "4444", @WinPos, FALSE)
			AuthOpt.usern = Allocate(Len(Username)+1)
			*AuthOpt.usern = Username
			AuthOpt.passhash = Allocate(Len(PassHash)+1)
			*AuthOpt.passhash = PassHash
			lpFunctions->SaveToIni("Porticula", "FBP_Auth", "00", @AuthOpt, FALSE)
			DeAllocate(AuthOpt.usern)
			DeAllocate(AuthOpt.passhash)
			lpFunctions->SaveToIni("Porticula", "Settings", "4444", @Sett, FALSE)
			ImageList_Destroy(hIml)
			If @fbpList(0) <> 0 Then
				For q As Integer = LBound(fbpList) To UBound(fbpList)
					Delete(fbpList(q))
				Next
			End If
			MutexDestroy(mutexCB)
			MutexDestroy(mutexApiVer)
			DestroyMenu(hContextMenu)

	end select
	return FALSE
End Function
